package image;

import java.awt.image.BufferedImage;
import java.io.ByteArrayInputStream;
import java.io.IOException;

import javax.persistence.DiscriminatorColumn;
import javax.persistence.DiscriminatorType;
import javax.persistence.DiscriminatorValue;
import javax.persistence.Entity;
import javax.persistence.Inheritance;
import javax.persistence.InheritanceType;

@Entity
@Inheritance(strategy=InheritanceType.JOINED)
@DiscriminatorColumn(discriminatorType=DiscriminatorType.INTEGER,name="type")
@DiscriminatorValue(value="74")
public class Thumb extends URI {
	public Thumb(){}
	@Override
	public byte[] getBaURI() {
		return baURI;
	}
	@Override
	public void setBaURI(byte[] baURI) {
		this.baURI = baURI;
	}
	public BufferedImage getBaImage() {
		ByteArrayInputStream bin = new ByteArrayInputStream(getBaURI());
		try {
			return javax.imageio.ImageIO.read(bin);
		} catch (IOException e) {
			e.printStackTrace();
			return null;
		}
	}

}
