package image;

import static util.SingleManager.em;
import static util.SingleManager.trans;

import java.io.EOFException;
import java.io.FileNotFoundException;
import java.io.IOException;

import org.yanglai.io.RandomAccessFile;

import util.SingleManager.eClass;

import com.objectdb.Enhancer;

public class URIReader {
	
	@SuppressWarnings("deprecation")
	public static int read(String src, eClass eName){
		int iCnt = 0;
		long lLenAvg = 0;
		URI uri = null;
		RandomAccessFile din = null;
		int iSpan = 0xFF;
		try {
			din = new RandomAccessFile(src, "r");
			long Len = din.length();
			trans.begin();
			while (lLenAvg/5 + din.getPos()<Len){
				switch (eName){
				case Page:
					uri = new Page();
					break;
				case Image:
					uri = new ImageSogou();
					break;
				case Thumb:
					uri = new Thumb();
					break;
				}
				String sLine;
				sLine = din.readLine().trim();
				while (null==sLine || sLine.length()==0){
					sLine = din.readLine();
				}
				uri.setsUrl(sLine);
				char cMark = ' ';
				sLine = din.readLine().trim();
				try {
					cMark = sLine.toLowerCase().charAt(0);
				} catch (Exception e1) {
					e1.printStackTrace();
					throw new IllegalAccessError("Error for mark");
				}
				uri.setcMark(cMark);
				switch (cMark){
				case 'p':
					String sSize = din.readLine();
					int iSize;
					try {
						iSize = Integer.parseInt(sSize);
					} catch (NumberFormatException e) {
						e.printStackTrace();
						System.out.println(String.format("Url: %s%nSize:%d%n%n", uri.getsUrl(), uri.getiSize()));
						iSize = 0xFFFFF;
					}
					byte[] baB = new byte[iSize];
					iSize = din.read(baB, 0, iSize);
					uri.setiSize(iSize);
					uri.setBaURI(baB);
//					System.out.println(new String(baB));
					din.readLine();
					break;
				case '=':
					break;
				case 'd':
					break;
				}
				em.persist(uri);
				if ((++iCnt & iSpan)==0){
					trans.commit();
					System.out.printf("NO = %d @ %d%n",iCnt, Len);
					System.out.printf("id = %d @ %d%n",uri.getId(), din.getPos());
					System.out.printf("Url = %s%n%n", uri.getsUrl());
					em.clear();
					trans.begin();
				}
				lLenAvg = din.getPos() / iCnt;
			}
			trans.commit();
			din.close();
		} catch (FileNotFoundException e) {
			e.printStackTrace();
		} catch (EOFException e){
			e.printStackTrace();
			System.out.printf("_____________File reach End! Close it Now!_________%n");
		} catch (IOException e) {
			e.printStackTrace();
		}finally{
			/*
			trans.commit();
			try {
				din.close();
			} catch (IOException e) {
				e.printStackTrace();
			}//*/
		}
		
		return iCnt;
	}
	public static void main(String[] args) {
        Enhancer.enhance("image.ImageSogou,image.Meta,image.Page,image.Thumb,image.URI");
		int i2 = URIReader.read("images", eClass.Image);
//		int i2 = URIReader.read("r:/SogouPIC/original_pic", eClass.Image);
//		int i3 = URIReader.read("r:/SogouPIC/zoomed_pic", eClass.Thumb);
//		int i1 = URIReader.read("r:/SogouPIC/pages", eClass.Page);
//		System.out.printf("pages = %d%n",i1);
//		System.out.printf("Images = %d%n",i2);
//		System.out.printf("Thumbs = %d%n",i3);
	}
}
